"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Highlight = _interopRequireDefault(require("./Highlight"));

var _text = require("./Highlight/utils/text");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TEXT = 'I am a dummy react a npm module www.google.com';

var App =
/*#__PURE__*/
function (_Component) {
  _inherits(App, _Component);

  function App() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, App);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(App)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      currentIndex: 1,
      keyword: '',
      total: 0,
      // totalContain: 0,
      // totalExact: 0,
      mode: 'contain'
    });

    _defineProperty(_assertThisInitialized(_this), "changeKeyword", function (e) {
      var text = TEXT;
      var value = e.target.value;

      if (value.replace(/\s/g, '').length) {
        var total = _this.findTotal(value, text);

        if (total === 0) {
          _this.setState({
            keyword: value,
            total: total,
            currentIndex: 0
          });
        } else {
          _this.setState({
            keyword: value,
            total: total,
            currentIndex: 1
          });
        }
      } else {
        _this.setState({
          keyword: '',
          total: 0,
          currentIndex: 1
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "findTotal", function (value, text) {
      var total = 0;
      var mode = _this.state.mode;

      if (mode === 'contain') {
        total = (0, _text.findTotalMatch)(value, text);
      } else {
        total = (0, _text.findTotalMatchExact)(value, text);
      }

      return total;
    });

    _defineProperty(_assertThisInitialized(_this), "next", function () {
      var _this$state = _this.state,
          total = _this$state.total,
          currentIndex = _this$state.currentIndex;

      if (total !== 0) {
        if (currentIndex === total) {
          _this.setState({
            currentIndex: 1
          });
        } else {
          _this.setState({
            currentIndex: _this.state.currentIndex + 1
          });
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "prev", function () {
      var _this$state2 = _this.state,
          total = _this$state2.total,
          currentIndex = _this$state2.currentIndex; // const { currentIndex, setCurrentIndex } = this.props

      if (total !== 0) {
        if (currentIndex === 1) {
          _this.setState({
            currentIndex: total
          }); // setCurrentIndex(total)

        } else {
          _this.setState({
            currentIndex: _this.state.currentIndex - 1
          }); // setCurrentIndex(total)
          // setCurrentIndex(currentIndex - 1)

        }
      }
    });

    return _this;
  }

  _createClass(App, [{
    key: "render",
    value: function render() {
      var text = TEXT; // const keyword = 'x'

      var _this$state3 = this.state,
          mode = _this$state3.mode,
          total = _this$state3.total;
      var aaa = (0, _text.findTotalMatch)(this.state.keyword, text); // console.log('currentIndex', this.state.currentIndex)
      // console.log('this.state.keyword', this.state.keyword)
      // console.log('this.state.total', this.state.total)
      // console.log(total, 77777)

      return _react["default"].createElement("div", null, "find ", this.state.mode, " ", _react["default"].createElement("input", {
        onChange: this.changeKeyword
      }), _react["default"].createElement("button", {
        onClick: this.changeMode
      }, "change mode"), _react["default"].createElement(_Highlight["default"], {
        findMode: mode,
        text: text,
        keyword: this.state.keyword,
        currentIndex: this.state.currentIndex
      }), _react["default"].createElement("button", {
        onClick: this.prev
      }, "prev"), _react["default"].createElement("button", {
        onClick: this.next
      }, "next"));
    }
  }]);

  return App;
}(_react.Component);

exports["default"] = App;
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _HighlightContain = _interopRequireDefault(require("./HighlightContain"));

var _HighlightExact = _interopRequireDefault(require("./HighlightExact"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// import { CHAT_HISTORY_MODE } from '@/lib/constants/chatHistory'
var Highlight = function Highlight(_ref) {
  var findMode = _ref.findMode,
      text = _ref.text,
      keyword = _ref.keyword,
      currentIndex = _ref.currentIndex;
  return findMode === 'contain' ? _react["default"].createElement(_HighlightContain["default"], {
    text: text,
    keyword: keyword,
    currentIndex: currentIndex
  }) : _react["default"].createElement(_HighlightExact["default"], {
    text: text,
    keywordExact: keyword,
    currentIndex: currentIndex
  });
};

Highlight.propTypes = {
  findMode: _propTypes["default"].string,
  text: _propTypes["default"].string,
  keyword: _propTypes["default"].string,
  currentIndex: _propTypes["default"].number
};
Highlight.defaultProps = {
  // findMode: CHAT_HISTORY_MODE.CONTAINS,
  text: '',
  keyword: ''
};
var _default = Highlight;
exports["default"] = _default;
// import React from 'react'
// import Enzyme, { shallow } from 'enzyme'
// import Adapter from 'enzyme-adapter-react-16'
// import Highlight from '@/components/common/Highlight'
// import HighlightContain from '@/components/common/Highlight/HighlightContain'
// import HighlightExact from '@/components/common/Highlight/HighlightExact'
// Enzyme.configure({ adapter: new Adapter() })
// describe('Component Highlight', () => {
//   it('render component Highlight when keywords are spaces properly', () => {
//     const wraper = shallow(
//       <Highlight
//         findMode="Contains"
//         text="I test highlight"
//         keyword=""
//         currentIndex={1}
//       />
//     )
//     expect(wraper.find(HighlightContain).length).toEqual(1)
//   })
//   it('render component Highlight when keywords are spaces properly', () => {
//     const wraper = shallow(
//       <Highlight
//         findMode="Exact"
//         text="I test highlight"
//         keyword="  "
//         currentIndex={1}
//       />
//     )
//     expect(wraper.find(HighlightExact).length).toEqual(1)
//   })
// })
"use strict";
// import React from 'react'
// import Enzyme, { shallow } from 'enzyme'
// import Adapter from 'enzyme-adapter-react-16'
// import HighlightContain from '@/components/common/Highlight/HighlightContain'
// Enzyme.configure({ adapter: new Adapter() })
// describe('Component HighlightContain', () => {
//   it('render component HighlightContain when keywords are spaces properly', () => {
//     const wraper = shallow(
//       <HighlightContain
//         text="I test highlight"
//         keyword="   "
//         currentIndex={0}
//       />
//     )
//     expect(wraper.find('.text-highlight-no-modify').length).toEqual(1)
//   })
//   it('render component HighlightContain when has keyword properly', () => {
//     const wraper = shallow(
//       <HighlightContain
//         text="H"
//         keyword="h"
//         currentIndex={1}
//       />
//     )
//     expect(wraper.find('.text-highlight-content').length).toEqual(0)
//   })
//   it('render component HighlightContain when has link properly', () => {
//     const wraper = shallow(
//       <HighlightContain
//         text="https://www.google.com"
//         keyword="http"
//         currentIndex={1}
//       />
//     )
//     expect(wraper.find('.text-focus-content').length).toEqual(1)
//   })
//   it('render component HighlightContain when has link properly', () => {
//     const wraper = shallow(
//       <HighlightContain
//         text="https://www.google.com"
//         keyword=""
//         currentIndex={0}
//       />
//     )
//     expect(wraper.find('.text-highlight-content').length).toEqual(0)
//   })
//   it('render component HighlightContain when has link and focus properly', () => {
//     const wraper = shallow(
//       <HighlightContain
//         text="https://www.google.com"
//         keyword="z"
//         currentIndex={0}
//       />
//     )
//     expect(wraper.find('.text-focus-content').length).toEqual(0)
//   })
//   it('render component HighlightContain when has link and focus properly', () => {
//     const wraper = shallow(
//       <HighlightContain
//         text="https://www.google.com"
//         keyword="h"
//         currentIndex={1}
//       />
//     )
//     expect(wraper.find('.text-focus-content').length).toEqual(1)
//   })
// })
"use strict";
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = require("../utils");

var _text = require("../utils/text");

require("../index.scss");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var HighlightContain = function HighlightContain(_ref) {
  var text = _ref.text,
      keyword = _ref.keyword,
      currentIndex = _ref.currentIndex;
  console.log(currentIndex);
  var hasPartOfLink = (0, _text.detectPartOfLink)(text);
  var linkIndices = (0, _text.initialList)(text.length, 0);
  var linkName = (0, _text.initialList)(text.length, 0);

  if (hasPartOfLink) {
    linkIndices = (0, _text.getIndicesOfLink)(text, linkIndices);
    linkName = (0, _text.getLinkUrl)(text, linkIndices);
  } // start display along as match and index logic


  var isKeywordHasAllSpace = keyword.trim();

  if (isKeywordHasAllSpace.length === 0) {
    // no keyword
    if (!hasPartOfLink) {
      return _react["default"].createElement("span", {
        className: "text-highlight-no-modify"
      }, text);
    } else if (hasPartOfLink) {
      return (0, _utils.displayTextWithLink)(text, linkIndices, linkName);
    }
  } // else is that it has keyword


  var modifiedText = text.toLowerCase();
  var trimedKeyword = keyword.toLowerCase().trim();
  var splitedKeywordList = trimedKeyword.split(new RegExp(/\s+/, 'gi'));

  var modifiedKeyword = _lodash["default"].uniq(splitedKeywordList); // start logic match with index


  var currentIndicesMatches = [(0, _text.initialList)(modifiedText.length, 0), []];
  modifiedKeyword.forEach(function (word) {
    if (word) {
      currentIndicesMatches = getIndicesOfMatchesContain(currentIndicesMatches[0], word, modifiedText, currentIndicesMatches[1]);
    }
  });
  var listOfIndicesUsed = currentIndicesMatches[0]; // listOfIndicesUsed means list of index that match

  var listOfIndexFocus = currentIndicesMatches[1]; // listOfIndexFocus means array of match and how many text it takes in text

  var indexAt = (0, _text.initialList)(modifiedText.length, 0);

  if (currentIndex === 0) {
    return (0, _utils.displayTextWithLinkWithHighlightWithFocus)(text, listOfIndicesUsed, linkIndices, linkName, indexAt);
  } // when listOfIndexFocus.length !== 0


  (0, _text.orderChatIndex)(listOfIndexFocus);
  var position = listOfIndexFocus[currentIndex - 1]; // console.log('indexAt',indexAt)

  indexAt.fill(1, position[0], position[0] + position[1]);
  return (0, _utils.displayTextWithLinkWithHighlightWithFocus)(text, listOfIndicesUsed, linkIndices, linkName, indexAt);
};

var getIndicesOfMatchesContain = function getIndicesOfMatchesContain(oldIndicesMatch, keyword, str, indexSpot) {
  var keywordLen = keyword.length;
  var result = oldIndicesMatch;
  var tempIndices = (0, _text.initialList)(oldIndicesMatch.length, 0);
  var startIndex = 0;
  var foundIndex = -1;

  do {
    foundIndex = str.indexOf(keyword, startIndex);

    if (foundIndex > -1) {
      result.fill(1, foundIndex, foundIndex + keywordLen);
      tempIndices.fill(1, foundIndex, foundIndex + keywordLen);
      indexSpot.push([foundIndex, keywordLen]);
      startIndex = foundIndex + 1;
    }
  } while (foundIndex > -1);

  return [result, indexSpot];
};

HighlightContain.propTypes = {
  text: _propTypes["default"].string,
  keyword: _propTypes["default"].string,
  currentIndex: _propTypes["default"].number
};
HighlightContain.defaultProps = {
  text: '',
  keyword: '',
  currentIndex: 1
};
var _default = HighlightContain;
exports["default"] = _default;
// import React from 'react'
// import Enzyme, { shallow } from 'enzyme'
// import Adapter from 'enzyme-adapter-react-16'
// import HighlightExact from '@/components/common/Highlight/HighlightExact'
// Enzyme.configure({ adapter: new Adapter() })
// describe('Component HighlightExact', () => {
//   it('render component HighlightExact when keywords are spaces properly', () => {
//     const wraper = shallow(
//       <HighlightExact
//         text="I test highlight"
//         keywordExact="     "
//         currentIndex={0}
//       />
//     )
//     expect(wraper.find('.text-highlight-no-modify').length).toEqual(1)
//   })
//   it('render component HighlightExact when keyword matches first word of content properly', () => {
//     const wraper = shallow(
//       <HighlightExact
//         text="Hi "
//         keywordExact="hi"
//         currentIndex={0}
//       />
//     )
//     expect(wraper.find('.text-highlight-content').length).toEqual(1)
//   })
//   it('render component HighlightExact when keyword matches middle word of content properly', () => {
//     const wraper = shallow(
//       <HighlightExact
//         text="  Hi "
//         keywordExact="hi"
//         currentIndex={1}
//       />
//     )
//     expect(wraper.find('.text-focus-content').length).toEqual(1)
//   })
//   it('render component HighlightExact when keyword matches last word of content properly', () => {
//     const wraper = shallow(
//       <HighlightExact
//         text="  Hi"
//         keywordExact="hi"
//         currentIndex={0}
//       />
//     )
//     expect(wraper.find('.text-highlight-content').length).toEqual(1)
//   })
//   it('render component HighlightExact when has link properly', () => {
//     const wraper = shallow(
//       <HighlightExact
//         text="https://www.google.com"
//         keywordExact="https://www.google.com"
//         currentIndex={1}
//       />
//     )
//     expect(wraper.find('.text-focus-content').length).toEqual(1)
//   })
//   it('render component HighlightExact when has index focus properly', () => {
//     const wraper = shallow(
//       <HighlightExact
//         text="https://www.google.com"
//         keywordExact="https://www.google.com"
//         currentIndex={1}
//       />
//     )
//     expect(wraper.find('.text-focus-content').length).toEqual(1)
//   })
//   it('render component HighlightExact when has no index focus properly', () => {
//     const wraper = shallow(
//       <HighlightExact
//         text="https://www.google.com"
//         keywordExact=""
//         currentIndex={0}
//       />
//     )
//     expect(wraper.find('.text-focus-content').length).toEqual(0)
//   })
// })
"use strict";
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = require("../utils");

var _text = require("../utils/text");

require("../index.scss");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var HighlightExact = function HighlightExact(_ref) {
  var text = _ref.text,
      keywordExact = _ref.keywordExact,
      currentIndex = _ref.currentIndex;
  var hasPartOfLink = (0, _text.detectPartOfLink)(text);
  var linkIndices = (0, _text.initialList)(text.length, 0);
  var linkName = (0, _text.initialList)(text.length, 0);

  if (hasPartOfLink) {
    linkIndices = (0, _text.getIndicesOfLink)(text, linkIndices);
    linkName = (0, _text.getLinkUrl)(text, linkIndices);
  } // start display along as match and index logic


  var isKeywordHasAllSpace = keywordExact.trim();

  if (isKeywordHasAllSpace.length === 0) {
    if (!hasPartOfLink) {
      return _react["default"].createElement("span", {
        className: "text-highlight-no-modify"
      }, text);
    } else if (hasPartOfLink) {
      return (0, _utils.displayTextWithLink)(text, linkIndices, linkName);
    }
  } // when has keyword


  var modifiedText = text.toLowerCase();
  var trimedKeywordExact = keywordExact.toLowerCase().trim(); // start logic match with index

  var listOfIndicesUseInText = getIndicesOfMatchesExact(modifiedText, trimedKeywordExact);
  var indexAt = (0, _text.initialList)(modifiedText.length, 0);

  if (currentIndex === 0) {
    return (0, _utils.displayTextWithLinkWithHighlightWithFocus)(text, listOfIndicesUseInText[0], linkIndices, linkName, indexAt);
  }

  var listOfIndicesUsed = listOfIndicesUseInText[0];
  var listOfIndexFocus = listOfIndicesUseInText[1];
  (0, _text.orderChatIndex)(listOfIndexFocus); // when listOfIndexFocus.length !== 0

  var position = listOfIndexFocus[currentIndex - 1];
  indexAt.fill(1, position[0], position[0] + position[1]);
  return (0, _utils.displayTextWithLinkWithHighlightWithFocus)(text, listOfIndicesUsed, linkIndices, linkName, indexAt);
};

var getIndicesOfMatchesExact = function getIndicesOfMatchesExact(text, word) {
  var textLength = text.length;
  var wordLength = word.length;
  var indexSpot = [];
  var resultListWithIndices = (0, _text.initialList)(textLength, 0);
  var startIndex = 0;
  var index = -1;
  var spaces = [' ', '\n', '\t'];

  if (text === word) {
    resultListWithIndices.fill(1);
    indexSpot.push([0, wordLength]);
  } else {
    index = text.indexOf(word, startIndex);

    while (index > -1) {
      if (index === 0 && spaces.includes(text[index + wordLength])) {
        // start of content
        resultListWithIndices.fill(1, index, index + wordLength);
        indexSpot.push([index, wordLength]);
      } else if (spaces.includes(text[index - 1]) && spaces.includes(text[index + wordLength])) {
        // middle of content
        resultListWithIndices.fill(1, index, index + wordLength);
        indexSpot.push([index, wordLength]);
      } else if (spaces.includes(text[index - 1]) && index + wordLength === textLength) {
        // last of content
        resultListWithIndices.fill(1, index, index + wordLength);
        indexSpot.push([index, wordLength]);
      }

      startIndex = index + wordLength;
      index = text.indexOf(word, startIndex);
    }
  } // collect [index that match, index when click next and how many it will take]


  return [resultListWithIndices, indexSpot];
};

HighlightExact.propTypes = {
  text: _propTypes["default"].string,
  keywordExact: _propTypes["default"].string,
  currentIndex: _propTypes["default"].number
};
HighlightExact.defaultProps = {
  text: '',
  keywordExact: '',
  currentIndex: 1
};
var _default = HighlightExact;
exports["default"] = _default;
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Highlight = _interopRequireDefault(require("./Highlight"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = _Highlight["default"];
exports["default"] = _default;
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _text = require("./text");

require("../index.scss");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var displayTextWithLink = function displayTextWithLink(text, linkIndices, linkName) {
  var tempTextLink;
  var textWithLink = [];
  var current = -1;
  var keyIndex = 0;
  linkIndices.map(function (item, index) {
    if (index === 0) {
      tempTextLink = text[index];
      current = item;
    } else if (item === current) {
      tempTextLink = "".concat(tempTextLink).concat(text[index]);
    } else if (item !== current) {
      textWithLink.push(_react["default"].createElement("span", {
        key: keyIndex,
        className: "text-highlight-no-modify"
      }, item === 0 ? _react["default"].createElement("a", {
        href: (0, _text.finalLink)(linkName[index - 1]),
        target: "_blank",
        className: "link-underline"
      }, tempTextLink) : tempTextLink));
      tempTextLink = text[index];
      current = item;
      keyIndex += 1;
    }

    if (index === linkIndices.length - 1) {
      textWithLink.push(_react["default"].createElement("span", {
        key: keyIndex,
        className: "text-highlight-no-modify"
      }, item === 1 ? _react["default"].createElement("a", {
        href: (0, _text.finalLink)(linkName[index]),
        target: "_blank",
        className: "link-underline"
      }, tempTextLink) : tempTextLink));
    }
  });
  return textWithLink;
};

var _default = displayTextWithLink;
exports["default"] = _default;
// import Enzyme from 'enzyme'
// import Adapter from 'enzyme-adapter-react-16'
// import displayTextWithLink from './text'
// Enzyme.configure({ adapter: new Adapter() })
// describe('call displayTextWithLink function', () => {
//   it('call displayTextWithLink properly', () => {
//     const result = displayTextWithLink('a', [0], [0])
//     expect(result[0].props.className).toEqual('text-highlight-no-modify')
//   })
//   it('call displayTextWithLink properly when has match', () => {
//     const result = displayTextWithLink('ab', [0, 0], [0, 0])
//     expect(result[0].props.className).toEqual('text-highlight-no-modify')
//   })
//   it('call displayTextWithLink properly when has link', () => {
//     const result = displayTextWithLink('www.a.com aa', [1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0], ['www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 0, 0, 0])
//     expect(result.length).toEqual(2)
//   })
//   it('call displayTextWithLink properly when has link', () => {
//     const result = displayTextWithLink('awww.a.com', [0, 1, 1, 1, 1, 1, 1, 1, 1, 1], [0, 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a'])
//     expect(result.length).toEqual(2)
//   })
// })
"use strict";
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _text = require("./text");

require("../index.scss");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var displayTextWithLinkWithHighlightWithFocus = function displayTextWithLinkWithHighlightWithFocus(text, match, link, linkName, indexAt) {
  var resultText = [];
  var keyIndex = 0;
  var temp = '';
  var current = -1;
  var value = [];
  match.forEach(function (item, index) {
    value.push(parseInt("".concat(match[index]).concat(link[index]).concat(indexAt[index]), 2).toString(10)); // m = has match, l = link, i = has index potision, ~ = not , [Y] = highlight yellow, [B] = highlight blue, [a] = <a/>
    // 0=000= ~(mli)      ,1=001= ~(ml)i [IMPOSSIBLE]  ,2=010 = ~ml~i [a]     ,3=011= ~mli [IMPOSSIBLE]
    // 4=100= m~(li) [Y]  ,5=101= m~li   [B]           ,6=110 = ml~i  [Y, a]  ,7=111= mli  [B, a]

    if (index === 0) {
      temp = text[index];
      current = value[index];
    } else if (value[index] === current) {
      temp = "".concat(temp).concat(text[index]);
    } else if (value[index] !== current) {
      resultText.push(_react["default"].createElement("span", {
        key: keyIndex,
        className: (0, _classnames["default"])('text-highlight-no-modify', {
          'text-highlight-content': ['4', '6'].includes(value[index - 1])
        }, {
          'text-focus-content': ['5', '7'].includes(value[index - 1])
        })
      }, ['2', '6', '7'].includes(value[index - 1]) ? _react["default"].createElement("a", {
        href: (0, _text.finalLink)(linkName[index - 1]),
        target: "_blank",
        className: "link-underline"
      }, temp) : temp));
      temp = text[index];
      current = value[index];
      keyIndex += 1;
    }

    if (index === match.length - 1) {
      resultText.push(_react["default"].createElement("span", {
        key: keyIndex,
        className: (0, _classnames["default"])('text-highlight-no-modify', {
          'text-highlight-content': ['4', '6'].includes(value[index])
        }, {
          'text-focus-content': ['5', '7'].includes(value[index])
        })
      }, ['2', '6', '7'].includes(value[index]) ? _react["default"].createElement("a", {
        href: (0, _text.finalLink)(linkName[index]),
        target: "_blank",
        className: "link-underline"
      }, temp) : temp));
    }
  });
  return resultText;
};

var _default = displayTextWithLinkWithHighlightWithFocus;
exports["default"] = _default;
// import Enzyme from 'enzyme'
// import Adapter from 'enzyme-adapter-react-16'
// import displayTextWithLinkWithHighlightWithFocus from '@/components/common/Highlight/utils/displayTextWithLinkWithHighlightWithFocus'
// Enzyme.configure({ adapter: new Adapter() })
// describe('call displayTextWithLinkWithHighlightWithFocus function', () => {
//   it('call displayTextWithHighlight properly when has match', () => {
//     const result = displayTextWithLinkWithHighlightWithFocus('ab', [1, 0], [0, 0], [0, 0], [0, 1])
//     expect(result[0].props.className).toEqual('text-highlight-no-modify text-highlight-content')
//   })
//   it('call displayTextWithLinkWithHighlightWithFocus properly when has link', () => {
//     const result = displayTextWithLinkWithHighlightWithFocus('www.a.com aa', [1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0], [1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0], ['www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 0, 0, 0], [1, 1])
//     expect(result.length).toEqual(3)
//   })
//   it('call displayTextWithLinkWithHighlightWithFocus properly when has match with link', () => {
//     const result = displayTextWithLinkWithHighlightWithFocus('awww.a.com', [0, 1, 1, 1, 1, 1, 1, 1, 1, 1], [0, 1, 1, 1, 1, 1, 1, 1, 1, 1], [0, 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a'], [1, 1])
//     expect(result.length).toEqual(3)
//   })
//   it('call displayTextWithLinkWithHighlightWithFocus properly when has link but no highlight', () => {
//     const result = displayTextWithLinkWithHighlightWithFocus('awww.a.com', [0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [0, 1, 1, 1, 1, 1, 1, 1, 1, 1], [0, 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a'], [1, 1])
//     expect(result.length).toEqual(3)
//   })
//   it('call displayTextWithLinkWithHighlightWithFocus properly when has link and highlight', () => {
//     const result = displayTextWithLinkWithHighlightWithFocus('awww.a.com', [0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [0, 1, 1, 1, 1, 1, 1, 1, 1, 1], [0, 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a', 'www.a'], 0)
//     expect(result.length).toEqual(2)
//   })
// })
"use strict";
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "displayTextWithLink", {
  enumerable: true,
  get: function get() {
    return _displayTextWithLink["default"];
  }
});
Object.defineProperty(exports, "displayTextWithLinkWithHighlightWithFocus", {
  enumerable: true,
  get: function get() {
    return _displayTextWithLinkWithHighlightWithFocus["default"];
  }
});

var _displayTextWithLink = _interopRequireDefault(require("./displayTextWithLink"));

var _displayTextWithLinkWithHighlightWithFocus = _interopRequireDefault(require("./displayTextWithLinkWithHighlightWithFocus"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.finalLink = exports.orderChatIndex = exports.getIndicesOfLink = exports.getLinkUrl = exports.detectPartOfLink = exports.initialList = exports.findTotalMatchExact = exports.findTotalMatch = exports.convertNumberToIndex = void 0;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

// import moment from 'moment'
// import _ from 'lodash'
// import { FULL_MONTH_FORMAT, TIME_FORMAT } from '@/lib/constants/global'
// export const groupByDate = (conversation) => {
//   return moment(parseInt(conversation.accepted_at, 10)).startOf('days').format('x')
// }
// export const countTotalCurrentMessage = chatMessages => _.flatten(Object.values(chatMessages)).length
var convertNumberToIndex = function convertNumberToIndex(totalMatch, startIndex, currentIndex) {
  var totalFoundIndex = startIndex - 1;
  var totalFoundMatch = Array(totalMatch).fill().map(function () {
    totalFoundIndex += 1;
    return totalFoundIndex;
  });

  if (totalFoundMatch.includes(currentIndex)) {
    return currentIndex - startIndex + 1;
  }

  return 0;
};

exports.convertNumberToIndex = convertNumberToIndex;

var findTotalMatch = function findTotalMatch(keyword, text) {
  var resultCount = 0;

  if (keyword) {
    var modifiedText = text.toLowerCase();
    var LowerCaseKeyword = keyword.toLowerCase();
    var trimedKeyword = LowerCaseKeyword.trim();
    var splitedKeywordList = trimedKeyword.split(new RegExp(/\s+/, 'gi'));

    var modifiedKeyword = _toConsumableArray(new Set(splitedKeywordList));

    modifiedKeyword.forEach(function (word) {
      var startIndex = 0;
      var foundIndex = -1;

      do {
        foundIndex = modifiedText.indexOf(word, startIndex);

        if (foundIndex > -1) {
          startIndex = foundIndex + 1;
          resultCount += 1;
        }
      } while (foundIndex > -1);
    });
  }

  return resultCount;
};

exports.findTotalMatch = findTotalMatch;

var findTotalMatchExact = function findTotalMatchExact(word, text) {
  var trimedKeyword = word.toLowerCase().trim();
  var modifiedText = text.toLowerCase();
  var resultCount = 0;
  var wordLength = trimedKeyword.length;
  var textLength = modifiedText.length;
  var startIndex = 0;
  var index = -1;
  var spaces = [' ', '\n', '\t'];

  if (word) {
    if (modifiedText === trimedKeyword) {
      resultCount += 1;
    } else {
      index = modifiedText.indexOf(trimedKeyword, startIndex);

      while (index > -1) {
        if (index === 0 && spaces.includes(text[index + wordLength])) {
          // start of content
          resultCount += 1;
        } else if (spaces.includes(modifiedText[index - 1]) && spaces.includes(modifiedText[index + wordLength])) {
          // middle of content
          resultCount += 1;
        } else if (spaces.includes(modifiedText[index - 1]) && index + wordLength === textLength) {
          // last of content
          resultCount += 1;
        }

        startIndex = index + wordLength;
        index = modifiedText.indexOf(trimedKeyword, startIndex);
      }
    }
  }

  return resultCount;
}; // export const downloadFile = (filePath) => {
//   const downloadLink = document.createElement('a')
//   downloadLink.download = filePath.split('?')[0].split('/').slice(-1).toString()
//   downloadLink.id = 'download'
//   const xhr = new XMLHttpRequest()
//   xhr.onload = () => {
//     const reader = new FileReader()
//     reader.onloadend = () => {
//       downloadLink.href = reader.result
//       if (document.getElementById('download') === null) {
//         document.body.appendChild(downloadLink)
//         downloadLink.click()
//         downloadLink.remove()
//       }
//     }
//     reader.readAsDataURL(xhr.response)
//   }
//   xhr.open('GET', filePath)
//   xhr.responseType = 'blob'
//   xhr.send()
// }
// export const convertCallDetailDateTime = (callDetailDateTime) => {
//   return moment(parseInt(callDetailDateTime, 10)).format(`${FULL_MONTH_FORMAT} [at] ${TIME_FORMAT}`)
// }


exports.findTotalMatchExact = findTotalMatchExact;

var initialList = function initialList(listLen, initialValue) {
  return Array(listLen).fill(initialValue);
};

exports.initialList = initialList;

var detectPartOfLink = function detectPartOfLink(text) {
  return ['http', 'www', '@'].some(function (i) {
    return text.includes(i);
  });
};

exports.detectPartOfLink = detectPartOfLink;

var getLinkUrl = function getLinkUrl(text, linkIndices) {
  var linkName = Array(text.length).fill(0);
  var start = -1;
  linkIndices.forEach(function (item, index) {
    if (item === 1) {
      if (start === -1) {
        start = index;
      }

      if (index === linkIndices.length - 1) {
        linkName.fill(text.substring(start), start);
      }
    } else if (item === 0) {
      linkName.fill(text.substring(start, index), start, index);
      start = -1;
    }
  });
  return linkName;
};

exports.getLinkUrl = getLinkUrl;

var getIndicesOfLink = function getIndicesOfLink(text, linkIndices) {
  var httpRegEx = /((https?:)\/\/[-a-zA-Z0-9&#=.\/?_%:()]+)/g;
  var wwwRegEx = /((www)[-a-z0-9&#=.\/?_%:()]+)/g;
  var emailRegEx = /(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))/g;
  var listPattern = [httpRegEx, wwwRegEx, emailRegEx];
  var urlResult;
  listPattern.forEach(function (regEx) {
    do {
      urlResult = regEx.exec(text);

      if (urlResult !== null) {
        var link = urlResult[0];
        var linkLen = link.length;
        var foundIndex = regEx.lastIndex - linkLen;
        linkIndices.fill(1, foundIndex, foundIndex + linkLen);
      }
    } while (urlResult !== null);
  });
  return linkIndices;
};

exports.getIndicesOfLink = getIndicesOfLink;

var orderChatIndex = function orderChatIndex(indexList) {
  return indexList.sort(function (startIndex, length) {
    if (startIndex[0] < length[0]) return -1;
    if (startIndex[0] > length[0]) return 1;
    if (startIndex[1] < length[1]) return -1;
    if (startIndex[1] > length[1]) return 1;
    return 0;
  });
};

exports.orderChatIndex = orderChatIndex;

var finalLink = function finalLink(link) {
  var emailRegEx = /(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))/gi;

  if (emailRegEx.exec(link) !== null) {
    return "mailto:".concat(link);
  } else if (link.substring(0, 4) === 'www.') {
    return "https://".concat(link);
  }

  return link;
};

exports.finalLink = finalLink;
// import React from 'react'
// import PropTypes from 'prop-types'
// import { Highlight, TagWithIcon } from '@/components/common'
// import './index.scss'
// const TagWithIconWithHighlight = ({
//   findMode,
//   className,
//   text,
//   icon,
//   keyword,
//   currentIndex,
//   ...props,
// }) => {
//   return (
//     <TagWithIcon
//       className={className}
//       text={
//         <Highlight
//           findMode={findMode}
//           text={text}
//           keyword={keyword}
//           currentIndex={currentIndex}
//         />
//        }
//       icon={icon}
//       {...props}
//     />
//   )
// }
// TagWithIconWithHighlight.propTypes = {
//   findMode: PropTypes.string,
//   className: PropTypes.string,
//   text: PropTypes.string,
//   icon: PropTypes.string,
//   keyword: PropTypes.string,
//   currentIndex: PropTypes.number,
// }
// TagWithIconWithHighlight.defaultProps = {
//   findMode: 'Contains',
//   className: '',
//   text: '',
//   icon: '',
//   keyword: '',
// }
// export default TagWithIconWithHighlight
"use strict";
"use strict";
"use strict";

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _App = _interopRequireDefault(require("./App"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

_reactDom["default"].render(_react["default"].createElement(_App["default"], null), document.getElementById('app'));
