import React from 'react'
import { finalLink } from './text'
import '../index.scss'

const displayTextWithLink = (text, linkIndices, linkName) => {
  let tempTextLink
  let textWithLink = []
  let current = -1
  let keyIndex = 0
  linkIndices.map((item, index) => {
    if (index === 0) {
      tempTextLink = text[index]
      current = item
    } else if (item === current) {
      tempTextLink = `${tempTextLink}${text[index]}`
    } else if (item !== current) {
      textWithLink.push(
        <span
          key={keyIndex}
          className="text-highlight-no-modify"
        >
          {
            item === 0 ?
              <a href={finalLink(linkName[index - 1])} target="_blank" className="link-underline">{tempTextLink}</a>
              :
              tempTextLink
          }
        </span>
      )
      tempTextLink = text[index]
      current = item
      keyIndex += 1
    }
    if (index === linkIndices.length - 1) {
      textWithLink.push(
        <span
          key={keyIndex}
          className="text-highlight-no-modify"
        >
          {
            item === 1 ?
              <a href={finalLink(linkName[index])} target="_blank" className="link-underline">{tempTextLink}</a>
              :
              tempTextLink
          }
        </span>
      )
    }
  })
  return textWithLink
}

export default displayTextWithLink
